﻿using DataLayer;
using NUnit.Framework;
using Rhino.Mocks;

namespace BusinessLayer.Tests
{
    [TestFixture]
    public class CommentsControllerTests
    {
        IRepository<Comment> _repository;
        private MockRepository _mocks;

        [Test]
        public void AddComment_ToBug_BugHasComment()
        {
            _mocks = new MockRepository();
            _repository = _mocks.CreateMock<IRepository<Comment>>();
            CommentsController controller = new CommentsController(_repository);

            Comment comment = new Comment();
            comment.BugID = 123;
            comment.UserID = 1;
            comment.ID = 1;
            comment.text = "Test";


            using (_mocks.Record())
                Expect.Call(_repository.Add(comment)).Return(true);

            using (_mocks.Playback())
            {
                bool result = controller.AddComment(comment);
                Assert.IsTrue(result, "Comment not inserted");
            }
        }
    }
}
