﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Mail;
using System.Text;
using DataLayer;

namespace BusinessLayer
{
    public class EmailService : IEmailService
    {
        public virtual void SendInsertNotification(Bug b)
        {
            try
            {
                CreateInsertBugMessage(b);
                //TODO: Send Email
            }
            catch
            {
                //TODO: Log this
            }
        }

        public MailMessage CreateInsertBugMessage(Bug bug)
        {
            if (bug.User == null)
                return null;

            MailMessage msg = new MailMessage("BugTracker@noreply", bug.User.email);
            msg.Subject = "New Bug: " + bug.ID;
            msg.Body = string.Format("New bug submitted ID {0} with the title of {1}", bug.ID, bug.Title);
            return msg;
        }
    }
}