﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Data.Linq;
using System.Linq.Expressions;

namespace DataLayer
{
    public class Repository<T> : IRepository<T> where T : class
    {
        private DatabaseDataContext db = null;

        public Repository()
        {
            db = new DatabaseDataContext();
        }

        private Table<T> Table
        {
            get { return db.GetTable<T>(); }
        }

        public bool Add(T b)
        {
            if (b == null)
                return false;

            Table.InsertOnSubmit(b);
            db.SubmitChanges();

            return Table.Contains(b);
        }

        public T Find(Func<T, bool> match)
        {
            return Table.Single(match);
        }

        public IQueryable<T> Where(Expression<Func<T, bool>> match)
        {
            return Table.Where(match);
        }

        #region IRepository<T> Members


        public bool Update(T updatedBug, T original)
        {
            Table.Attach(updatedBug, original);
            db.SubmitChanges();
            return true;
        }

        public bool Update()
        {
            db.SubmitChanges();

            return true;
        }

        #endregion
    }
}
